Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 716)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 717)
@@ -1,11 +1,13 @@
 MODULE traadv_cen2
-   !!==============================================================================
-   !!                       ***  MODULE  traadv_cen2  ***
+   !!======================================================================
+   !!                     ***  MODULE  traadv_cen2  ***
    !! Ocean active tracers:  horizontal & vertical advective trend
-   !!==============================================================================
-   !! History :  8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv 
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!            " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!======================================================================
+   !! History :   8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad=traadv 
+   !!             8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!             9.0  !  04-08  (C. Talandier) New trends organization
+   !!             " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!             " "  !  06-07  (G. madec)  add ups_orca_set routine
    !!----------------------------------------------------------------------
 
@@ -14,4 +16,6 @@
    !!                  vertical advection trends using a seconder order
    !!                  centered scheme. (k-j-i loops)
+   !!   ups_orca_set : allow mixed upstream/centered scheme in specific
+   !!                  area (set for orca 2 and 4 only)
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers
@@ -21,6 +25,8 @@
    USE trdmod_oce      ! ocean variables trends
    USE trdmod          ! ocean active tracers trends 
+   USE closea          ! closed sea
    USE trabbl          ! advective term in the BBL
    USE ocfzpt          !
+   USE sbcrnf          ! river runoffs
    USE in_out_manager  ! I/O manager
    USE lib_mpp
@@ -32,5 +38,9 @@
    PRIVATE
 
-   PUBLIC   tra_adv_cen2   ! routine called by step.F90
+   PUBLIC   tra_adv_cen2    ! routine called by step.F90
+   PUBLIC   ups_orca_set    ! routine used by traadv_cen2_jki.F90
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   upsmsk    !: mixed upstream/centered scheme near some straits 
+   !                                                   !  and in closed seas (orca 2 and 4 configurations)
 
    REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
@@ -40,5 +50,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -119,14 +129,13 @@
       !!
       INTEGER  ::   ji, jj, jk                           ! dummy loop indices
-      REAL(wp) ::                           &
-         zbtr, zta, zsa, zfui, zfvj,        &  ! temporary scalars
-         zhw, ze3tr, zcofi, zcofj,          &  !    "         "
-         zupsut, zupsvt, zupsus, zupsvs,    &  !    "         "
-         zfp_ui, zfp_vj, zfm_ui, zfm_vj,    &  !    "         "
-         zcofk, zupst, zupss, zcent,        &  !    "         "
-         zcens, zfp_w, zfm_w,               &  !    "         "
-         zcenut, zcenvt, zcenus, zcenvs,    &  !    "         "
-         z_hdivn_x, z_hdivn_y, z_hdivn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace 
+      REAL(wp) ::   zta, zsa, zbtr, zhw, ze3tr,       &  ! temporary scalars
+         &          zfp_ui, zfp_vj, zfp_w , zfui  ,   &  !    "         "
+         &          zfm_ui, zfm_vj, zfm_w , zfvj  ,   &  !    "         "
+         &          zcofi , zcofj , zcofk ,           &  !    "         "
+         &          zupsut, zupsus, zcenut, zcenus,   &  !    "         "
+         &          zupsvt, zupsvs, zcenvt, zcenvs,   &  !    "         "
+         &          zupst , zupss , zcent , zcens ,   &  !    "         "
+         &          z_hdivn_x, z_hdivn_y, z_hdivn 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
       !!----------------------------------------------------------------------
@@ -137,6 +146,10 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~   Vector optimization case'
          IF(lwp) WRITE(numout,*)
-         ! 
-         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
+         !
+         upsmsk(:,:) = 0.e0                              ! not upstream by default
+         IF( cp_cfg == "orca" )   CALL ups_orca_set      ! set mixed Upstream/centered scheme near some straits
+         !                                               ! and in closed seas (orca2 and orca4 only)
+         !   
+         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )        ! inverse of T-point surface
       ENDIF
 
@@ -146,10 +159,10 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zind(ji,jj,jk) =  MAX ( upsrnfh(ji,jj) * upsrnfz(jk),     &  ! changing advection scheme near runoff
-                  &                    upsadv(ji,jj)                     &  ! in the vicinity of some straits
+               zind(ji,jj,jk) = MAX (   &
+                  rnfmsk(ji,jj) * rnfmsk_z(jk),      &  ! near runoff mouths (& closed sea outflows)
+                  upsmsk(ji,jj)                      &  ! some of some straits
 #if defined key_ice_lim
-                  &                  , tmask(ji,jj,jk)                   &  ! half upstream tracer fluxes
-                  &                  * MAX( 0., SIGN( 1., fzptn(ji,jj)   &  ! if tn < ("freezing"+0.1 )
-                  &                                +0.1-tn(ji,jj,jk) ) ) &
+                  !                                     ! below ice covered area (if tn < "freezing"+0.1 )
+                  , MAX(  0., SIGN( 1., fzptn(ji,jj) + 0.1 - tn(ji,jj,jk) )  ) * tmask(ji,jj,jk)   &
 #endif
                   &                  )
@@ -158,7 +171,8 @@
       END DO
 
-
-      !  Horizontal advective fluxes
-      ! -----------------------------
+      ! I. Horizontal advective fluxes
+      ! ------------------------------
+      !  Second order centered tracer flux at u and v-points
+      ! -----------------------------------------------------
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -208,11 +222,9 @@
                zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)
 #endif
-               ! horizontal advective trends
-               zta = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &
+               zta = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &    ! horizontal advective trends
                   &            + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk)  )
                zsa = - zbtr * (  zww(ji,jj,jk) - zww(ji-1,jj  ,jk)   &
                   &            + zwz(ji,jj,jk) - zwz(ji  ,jj-1,jk)  )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
+               ta(ji,jj,jk) = ta(ji,jj,jk) + zta                          ! add it to the general tracer trends
                sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
             END DO
@@ -279,7 +291,5 @@
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
 
-      ! 4. "zonal" mean advective heat and salt transport 
-      ! -------------------------------------------------
-
+      ! "zonal" mean advective heat and salt transport
       IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
          IF( lk_zco ) THEN
@@ -313,24 +323,18 @@
       ENDIF
 
-      ! 1. Vertical advective fluxes
+      ! 1. Vertical advective fluxes (Second order centered tracer flux at w-point)
       ! ----------------------------
-      ! Second order centered tracer flux at w-point
       DO jk = 2, jpk
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! upstream indicator
-               zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) )
-               ! velocity * 1/2
-               zhw = 0.5 * pwn(ji,jj,jk)
-               ! upstream scheme
-               zfp_w = zhw + ABS( zhw )
+               zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) )         ! upstream indicator
+               zhw = 0.5 * pwn(ji,jj,jk)                               ! velocity * 1/2
+               zfp_w = zhw + ABS( zhw )                                ! upstream scheme
                zfm_w = zhw - ABS( zhw )
                zupst = zfp_w * tb(ji,jj,jk) + zfm_w * tb(ji,jj,jk-1)
                zupss = zfp_w * sb(ji,jj,jk) + zfm_w * sb(ji,jj,jk-1)
-               ! centered scheme
-               zcent = zhw * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) )
+               zcent = zhw * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) )         ! centered scheme
                zcens = zhw * ( sn(ji,jj,jk) + sn(ji,jj,jk-1) )
-               ! mixed centered / upstream scheme
-               zwx(ji,jj,jk) = zcofk * zupst + (1.-zcofk) * zcent
+               zwx(ji,jj,jk) = zcofk * zupst + (1.-zcofk) * zcent      ! mixed centered / upstream scheme
                zwy(ji,jj,jk) = zcofk * zupss + (1.-zcofk) * zcens
             END DO
@@ -344,9 +348,7 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                ze3tr = 1. / fse3t(ji,jj,jk)
-               ! vertical advective trends
-               zta = - ze3tr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
+               zta = - ze3tr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )     ! vertical advective trends
                zsa = - ze3tr * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) =  ta(ji,jj,jk) + zta
+               ta(ji,jj,jk) =  ta(ji,jj,jk) + zta                      ! add it to the general tracer trends
                sa(ji,jj,jk) =  sa(ji,jj,jk) + zsa
             END DO
@@ -387,4 +389,65 @@
       !
    END SUBROUTINE tra_adv_cen2
+   
+   
+   SUBROUTINE ups_orca_set
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE ups_orca_set  ***
+      !!       
+      !! ** Purpose :   add a portion of upstream scheme in area where the
+      !!                centered scheme generates too strong overshoot
+      !!
+      !! ** Method  :   orca (R4 and R2) confiiguration setting. Set upsmsk
+      !!                array to nozero value in some straith. 
+      !!
+      !! ** Action : - upsmsk set to 1 at some strait, 0 elsewhere for orca
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ii0, ii1, ij0, ij1      ! temporary integers
+      !!----------------------------------------------------------------------
+      
+      ! mixed upstream/centered scheme near river mouths
+      ! ------------------------------------------------
+      SELECT CASE ( jp_cfg )
+      !                                        ! =======================
+      CASE ( 4 )                               !  ORCA_R4 configuration 
+         !                                     ! =======================
+         !                                          ! Gibraltar Strait
+         ii0 =  70   ;   ii1 =  71
+         ij0 =  52   ;   ij1 =  53   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         !
+         !                                     ! =======================
+      CASE ( 2 )                               !  ORCA_R2 configuration 
+         !                                     ! =======================
+         !                                          ! Gibraltar Strait
+         ij0 = 102   ;   ij1 = 102
+         ii0 = 138   ;   ii1 = 138   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.20
+         ii0 = 139   ;   ii1 = 139   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.40
+         ii0 = 140   ;   ii1 = 140   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ij0 = 101   ;   ij1 = 102
+         ii0 = 141   ;   ii1 = 141   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         !                                          ! Bab el Mandeb Strait
+         ij0 =  87   ;   ij1 =  88
+         ii0 = 164   ;   ii1 = 164   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.10
+         ij0 =  88   ;   ij1 =  88
+         ii0 = 163   ;   ii1 = 163   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ii0 = 162   ;   ii1 = 162   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.40
+         ii0 = 160   ;   ii1 = 161   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ij0 =  89   ;   ij1 =  89
+         ii0 = 158   ;   ii1 = 160   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ij0 =  90   ;   ij1 =  90
+         ii0 = 160   ;   ii1 = 160   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         !                                          ! Sound Strait
+         ij0 = 116   ;   ij1 = 116
+         ii0 = 144   ;   ii1 = 144   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ii0 = 145   ;   ii1 = 147   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ii0 = 148   ;   ii1 = 148   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         !
+      END SELECT 
+      
+      ! mixed upstream/centered scheme over closed seas
+      ! -----------------------------------------------
+      CALL clo_ups( upsmsk(:,:) )
+      !
+   END SUBROUTINE ups_orca_set
 
    !!======================================================================
Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90	(revision 716)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90	(revision 717)
@@ -4,15 +4,17 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :  8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!            " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !! History :   8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv
+   !!             8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!             9.0  !  04-08  (C. Talandier) New trends organization
+   !!             " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!             " "  !  06-07  (G. madec)  add ups_orca_set routine
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   tra_adv_cen2_jki : update the tracer trend with the horizontal and
-   !!                  vertical advection trends using a seconder order
-   !!                  centered scheme. Auto-tasking case, k-slab for
-   !!                  hor. adv., j-slab for vert. adv. (j-k-i loops)
+   !!                      vertical advection trends using a seconder order
+   !!                      centered scheme. Auto-tasking case, k-slab for
+   !!                      hor. adv., j-slab for vert. adv. (j-k-i loops)
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers
@@ -26,14 +28,15 @@
    USE lib_mpp
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
+   USE sbcrnf          ! river runoffs
    USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
    USE prtctl          ! Print control
-
+   
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_adv_cen2_jki   ! routine called by step.F90
-
-   REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
+   PUBLIC   tra_adv_cen2_jki    ! routine called by step.F90
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   btr2    ! inverse of T-point surface [1/(e1t*e2t)]
 
    !! * Substitutions
@@ -87,4 +90,6 @@
       !!         zta+tn*divn=1/(e1t*e2t*e3t) { mi-1( e2u*e3u  un  di[tn] )
       !!                                      +mj-1( e1v*e3v  vn  mj[tn] )  }
+      !!         C A U T I O N : the trend saved is the centered trend only.
+      !!      It does not take into account the upstream part of the scheme.
       !!         NB:in z-coordinate - full step (ln_zco=T) e3u=e3v=e3t, so 
       !!      they vanish from the expression of the flux and divergence.
@@ -109,28 +114,26 @@
       !!
       !! ** Action :  - update (ta,sa) with the now advective tracer trends
-      !!              - save trends in (ztrdt,ztrds) ('key_trdtra')
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   zwx => ua   ! use ua as workspace
-      USE oce, ONLY :   zwy => va   ! use va as workspace
-      !!
-      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
-      !!
+      USE oce               ,   zwx => ua          ! use ua as workspace
+      USE oce               ,   zwy => va          ! use va as workspace
+      USE traadv_cen2, ONLY :   ups_orca_set,   &  ! upstream indicator near some straits 
+         &                      upsmsk             ! and over closed sea (orca 2 and 4)
+
+      INTEGER , INTENT(in)                         ::   kt              ! ocean time-step index
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun, pvn, pwn   ! now ocean velocity fields
+
       INTEGER  ::   ji, jj, jk                           ! dummy loop indices
-      REAL(wp) ::                           &
-         zbtr, zta, zsa, zfui, zfvj,        &  ! temporary scalars
-         zhw, ze3tr, zcofi, zcofj,          &  !    "         "
-         zupsut, zupsvt, zupsus, zupsvs,    &  !    "         "
-         zfp_ui, zfp_vj, zfm_ui, zfm_vj,    &  !    "         "
-         zcofk, zupst, zupss, zcent,        &  !    "         "
-         zcens, zfp_w, zfm_w,               &  !    "         "
-         zcenut, zcenvt, zcenus, zcenvs,    &  !    "         "
-         z_hdivn_x, z_hdivn_y, z_hdivn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace 
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
+      REAL(wp) ::   zta, zsa, zbtr, zhw, ze3tr,       &  ! temporary scalars
+         &          zfp_ui, zfp_vj, zfp_w , zfui  ,   &  !    "         "
+         &          zfm_ui, zfm_vj, zfm_w , zfvj  ,   &  !    "         "
+         &          zcofi , zcofj , zcofk ,           &  !    "         "
+         &          zupsut, zupsus, zcenut, zcenus,   &  !    "         "
+         &          zupsvt, zupsvs, zcenvt, zcenvs,   &  !    "         "
+         &          zupst , zupss , zcent , zcens ,   &  !    "         "
+         &          z_hdivn_x, z_hdivn_y, z_hdivn 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind,   &  ! temporary workspace arrays
+         &                                  zww, ztrds             !    "         "
       !!----------------------------------------------------------------------
-
+      !
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
@@ -138,6 +141,10 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   Auto-tasking case'
          IF(lwp) WRITE(numout,*)
-         !
-         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
+         !         
+         upsmsk(:,:) = 0.e0                              ! not upstream by default
+         IF( cp_cfg == "orca" )   CALL ups_orca_set      ! set mixed Upstream/centered scheme near some straits
+         !                                               ! and in closed seas (orca2 and orca4 only)
+
+         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )        ! inverse of T-point surface
       ENDIF
 
@@ -147,37 +154,36 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-         !  Upstream / centered scheme indicator
-         ! --------------------------------------
+
+         ! 0. Upstream / centered scheme indicator
+         ! ---------------------------------------
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zind(ji,jj,jk) =  MAX (              &
-                  upsrnfh(ji,jj) * upsrnfz(jk),     &  ! changing advection scheme near runoff
-                  upsadv(ji,jj)                     &  ! in the vicinity of some straits
+               zind(ji,jj,jk) = MAX (   &
+                  rnfmsk(ji,jj) * rnfmsk_z(jk),      &  ! near runoff mouths (& closed sea outflows)
+                  upsmsk(ji,jj)                      &  ! some of some straits
 #if defined key_ice_lim
-                  , tmask(ji,jj,jk)                 &  ! half upstream tracer fluxes if tn < ("freezing"+0.1 )
-                  * MAX( 0., SIGN( 1., fzptn(ji,jj)+0.1-tn(ji,jj,jk) ) )   &
-#endif
-               )
-            END DO
-         END DO
-
-         !  Horizontal advective fluxes
-         ! -----------------------------
+                  !                                     ! below ice covered area (if tn < "freezing"+0.1 )
+                  , MAX(  0., SIGN( 1., fzptn(ji,jj) + 0.1 - tn(ji,jj,jk) )  ) * tmask(ji,jj,jk)   &
+#endif
+                  &                  )
+            END DO
+         END DO
+
+
+         ! I. Horizontal advective fluxes
+         ! ------------------------------
          ! Second order centered tracer flux at u and v-points
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               ! upstream indicator
-               zcofi = MAX( zind(ji+1,jj,jk), zind(ji,jj,jk) )
+               zcofi = MAX( zind(ji+1,jj,jk), zind(ji,jj,jk) )               ! upstream indicator
                zcofj = MAX( zind(ji,jj+1,jk), zind(ji,jj,jk) )
-               ! volume fluxes * 1/2
-#if defined key_zco
-               zfui = 0.5 * e2u(ji,jj) * pun(ji,jj,jk)
+#if defined key_zco
+               zfui = 0.5 * e2u(ji,jj) * pun(ji,jj,jk)                       ! volume fluxes * 1/2 (zco)
                zfvj = 0.5 * e1v(ji,jj) * pvn(ji,jj,jk)
 #else
-               zfui = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
+               zfui = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)     ! volume fluxes * 1/2
                zfvj = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
 #endif
-               ! upstream scheme
-               zfp_ui = zfui + ABS( zfui )
+               zfp_ui = zfui + ABS( zfui )                                   ! upstream scheme
                zfp_vj = zfvj + ABS( zfvj )
                zfm_ui = zfui - ABS( zfui )
@@ -187,11 +193,9 @@
                zupsus = zfp_ui * sb(ji,jj,jk) + zfm_ui * sb(ji+1,jj  ,jk)
                zupsvs = zfp_vj * sb(ji,jj,jk) + zfm_vj * sb(ji  ,jj+1,jk)
-               ! centered scheme
-               zcenut = zfui * ( tn(ji,jj,jk) + tn(ji+1,jj  ,jk) )
+               zcenut = zfui * ( tn(ji,jj,jk) + tn(ji+1,jj  ,jk) )           ! centered scheme
                zcenvt = zfvj * ( tn(ji,jj,jk) + tn(ji  ,jj+1,jk) )
                zcenus = zfui * ( sn(ji,jj,jk) + sn(ji+1,jj  ,jk) )
                zcenvs = zfvj * ( sn(ji,jj,jk) + sn(ji  ,jj+1,jk) )
-               ! mixed centered / upstream scheme
-               zwx(ji,jj,jk) = zcofi * zupsut + (1.-zcofi) * zcenut
+               zwx(ji,jj,jk) = zcofi * zupsut + (1.-zcofi) * zcenut          ! mixed centered / upstream scheme
                zwy(ji,jj,jk) = zcofj * zupsvt + (1.-zcofj) * zcenvt
                zww(ji,jj,jk) = zcofi * zupsus + (1.-zcofi) * zcenus
@@ -200,19 +204,19 @@
          END DO
 
-         ! Tracer flux divergence at t-point added to the general trend
+         ! 2. Tracer flux divergence at t-point added to the general trend
+         ! ---------------------------------------------------------------
+
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
 #if defined key_zco
-               zbtr = btr2(ji,jj) 
-#else
-               zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)
-#endif
-               ! horizontal advective trends
-               zta = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &
+               zbtr = btr2(ji,jj)                                           ! inverse of the volume (zco)
+#else
+               zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)                         ! inverse of the volume
+#endif
+               zta = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)   &      ! horizontal advective trends
                   &            + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk)  )
                zsa = - zbtr * (  zww(ji,jj,jk) - zww(ji-1,jj  ,jk)   &
                   &            + zwz(ji,jj,jk) - zwz(ji  ,jj-1,jk)  )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
+               ta(ji,jj,jk) = ta(ji,jj,jk) + zta                            ! add it to the general tracer trends
                sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
             END DO
@@ -225,5 +229,5 @@
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
 
-      ! Save the horizontal advective trends for diagnostics
+      ! 3. Save the horizontal advective trends for diagnostic
       IF( l_trdtra )   THEN
          ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
@@ -298,6 +302,6 @@
       ENDIF
 
-      !  Vertical advection
-      ! --------------------
+      ! II. Vertical advection
+      ! ----------------------
 !CDIR PARALLEL DO
 !$OMP PARALLEL DO
@@ -312,39 +316,34 @@
          IF( lk_dynspg_rl ) THEN                          ! rigid lid : flux set to zero
             zwz(:,jj, 1 ) = 0.e0    ;    zww(:,jj, 1 ) = 0.e0
-         ELSE                                             ! free surface-constant volume
+         ELSE                                             ! free surface-constant volume : advection across the surface
             zwz(:,jj, 1 ) = pwn(:,jj,1) * tn(:,jj,1)
             zww(:,jj, 1 ) = pwn(:,jj,1) * sn(:,jj,1)
          ENDIF
          
-         ! Vertical advective fluxes at w-point
+         ! 1. Vertical advective fluxes (Second order centered tracer flux at w-point)
+         ! ----------------------------
          DO jk = 2, jpk
             DO ji = 2, jpim1
-               ! upstream indicator
-               zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) )
-               ! velocity * 1/2
-               zhw = 0.5 * pwn(ji,jj,jk)
-               ! upstream scheme
-               zfp_w = zhw + ABS( zhw )
+               zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) )          ! upstream indicator
+               zhw = 0.5 * pwn(ji,jj,jk)                                ! velocity * 1/2
+               zfp_w = zhw + ABS( zhw )                                 ! upstream scheme
                zfm_w = zhw - ABS( zhw )
                zupst = zfp_w * tb(ji,jj,jk) + zfm_w * tb(ji,jj,jk-1)
                zupss = zfp_w * sb(ji,jj,jk) + zfm_w * sb(ji,jj,jk-1)
-               ! centered scheme
-               zcent = zhw * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) )
+               zcent = zhw * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) )          ! centered scheme
                zcens = zhw * ( sn(ji,jj,jk) + sn(ji,jj,jk-1) )
-               ! mixed centered / upstream scheme
-               zwz(ji,jj,jk) = zcofk * zupst + (1.-zcofk) * zcent
+               zwz(ji,jj,jk) = zcofk * zupst + (1.-zcofk) * zcent       ! mixed centered / upstream scheme
                zww(ji,jj,jk) = zcofk * zupss + (1.-zcofk) * zcens
             END DO
          END DO
 
-         ! Tracer flux divergence at t-point added to the general trend
+         ! 2. Tracer flux divergence at t-point added to the general trend
+         ! -------------------------
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
                ze3tr = 1. / fse3t(ji,jj,jk)
-               ! vertical advective trends
-               zta = - ze3tr * ( zwz(ji,jj,jk) - zwz(ji,jj,jk+1) )
+               zta = - ze3tr * ( zwz(ji,jj,jk) - zwz(ji,jj,jk+1) )      ! vertical advective trends
                zsa = - ze3tr * ( zww(ji,jj,jk) - zww(ji,jj,jk+1) )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) =  ta(ji,jj,jk) + zta
+               ta(ji,jj,jk) =  ta(ji,jj,jk) + zta                       ! add it to the general tracer trends
                sa(ji,jj,jk) =  sa(ji,jj,jk) + zsa
             END DO
@@ -354,5 +353,6 @@
       !                                                ! ===============
 
-      ! Save the vertical advective trends for diagnostic
+      ! 3. Save the vertical advective trends for diagnostic
+      ! ----------------------------------------------------
       IF( l_trdtra )   THEN
          ! Recompute the vertical advection zta & zsa trends computed 
Index: trunk/NEMO/OPA_SRC/ice_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ice_oce.F90	(revision 716)
+++ trunk/NEMO/OPA_SRC/ice_oce.F90	(revision 717)
@@ -39,12 +39,4 @@
       fcalving            !: Iceberg calving 
 # endif
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !: field exchanges with ice model to ocean
-      sst_io, sss_io , &  !: sea surface temperature (C) and salinity (PSU)
-      u_io  , v_io   , &  !: velocity at ice surface (m/s)
-      fsolar, fnsolar, &  !: solar and non-solar heat fluxes (W/m2)
-      fsalt , fmass  , &  !: salt and freshwater fluxes
-      ftaux , ftauy  , &  !: wind stresses
-      gtaux , gtauy       !: wind stresses
    
    REAL(wp), PUBLIC ::   &  !:
@@ -59,7 +51,4 @@
 #endif
 
-   INTEGER, PUBLIC ::   &  !: namdom : space/time domain (namlist)
-      nfice =  5           !: coupling frequency OPA ICELLN  nfice 
-
    !!----------------------------------------------------------------------
 END MODULE ice_oce
